10 REM ***********************************************************************
11 REM *                                                                     *
12 REM * Name: ATTACHE                                                       *
13 REM * Rev.: 1.0                                                           *
14 REM * Date: May 14, 1982                                                  *
15 REM *                                                                     *
16 REM * Desc: Free-running demonstration of ATTACHE capabilities            *
17 REM *                                                                     *
18 REM *                                                                     *
19 REM ***********************************************************************
100 REM
101 REM		MAINLINE FOR DEMO PROGRAM
102 REM
110 GOSUB 60000:REM INITIALIZE
111 REM
120 WHILE DEMO = 1
130      FOR SCREEN = 1 TO NMSCRN
140          ON SCREEN GOSUB 11000,12000,13000,14000,15000,16000,

                 17000,18000,19000,20000
150          GOSUB 1000: REM PAUSE
160      NEXT SCREEN
170 WEND
180 GRAPH A: GRAPH F: REM CLEAR TEXT & GR
190 SYSTEM
1000 REM
1010 REM
1020 REM	PAUSE ROUTINE
1030 REM
1040 PAUSE = DELAY(SCREEN)
1050 FOR I = 1 TO PAUSE
1060 A$ = INKEY$: IF LEN(A$) = 0 THEN 1080
1070 IF ASC(A$) = 24 THEN DEMO = 0
1075 IF ASC(A$) = 32 THEN GOTO 1090
1080 NEXT I
1090 RETURN
2000 REM
2010 REM
2020 REM	SCREEN CONTROL SECTION
2030 REM
2100 REM ***************************************************************
2110 REM
2120 REM	CURSOR POSITIONING TEXT
2130 REM
2135 PRINT
2140 GRAPH L(SCRN%(SCREEN,LYNE,2)+1,SCRN%(SCREEN,LYNE,3)+1)
2150 RETURN
2200 REM
2210 REM
2220 REM	CHARACTER SET
2230 REM
2240 PRINT CHR$(ESC);"T";MID$(STR$(SCRN%(SCREEN,LYNE,4)),2);
2250 RETURN
2300 REM
2310 REM
2320 REM	CHARACTER SIZE
2330 REM
2340 PRINT CHR$(ESC);"S";MID$(STR$(SCRN%(SCREEN,LYNE,5)),2);
2350 RETURN
2400 REM
2410 REM
2420 REM	SCREEN ATTRIBUTE
2430 REM
2440 PRINT CHR$(ESC);"U";CHR$(SCRN%(SCREEN,LYNE,6));
2450 RETURN
2500 REM
2510 REM
2520 REM	CLEAR SCREEN
2530 REM
2540 PRINT CHR$(26)
2550 RETURN
2600 REM
2610 REM
2620 REM	RESET SCREEN ATTRIBUTES
2630 REM
2640 PRINT CHR$(ESC);"Z"
2650 RETURN
2700 REM
2710 REM
2720 REM	CLEAR GRAPHICS
2730 REM
2740 GRAPH F
2750 RETURN
2800 REM
2810 REM
2820 REM	GRAPHICS DRIVER
2830 REM
2840 IF P$ = "0" THEN PLOT (X,Y)
2850 IF P$ = "1" THEN PLOT TO (X,Y)
2860 RETURN
2900 REM
2910 REM
2920 REM	DIRECT CURSOR POSITIONING
2930 REM	FOR IMBEDDED PROGRAMS
2940 REM
2950 GRAPH L(L+1,C+1)
2960 RETURN
3000 REM
3010 REM
3020 REM	SCREEN PRINT ROUTINES
3030 REM
3100 REM
3110 REM
3120 REM	STANDARD TEXT
3130 REM
3140 IF SCRN%(SCREEN,1,7) > 0 THEN GOSUB 2500 : REM CLR SCRN
3145 IF SCRN%(SCREEN,1,8) > 0 THEN GOSUB 2700 : REM CLR GRPH
3150 FOR LYNE = 1 TO SCRN%(SCREEN,0,0)
3160    IF SCRN%(SCREEN,LYNE,1) > 0 THEN GOSUB 2100 : REM CUR POS
3165	GOSUB 2200 : REM CHAR SET
3170	GOSUB 2300 : REM CHAR SIZE
3175	IF SCRN%(SCREEN,LYNE,6) > 0 THEN GOSUB 2400 : REM ATTRIB
3180	PRINT SCREEN$(SCREEN,LYNE)
3185    GOSUB 2600: REM RESET SCREEN
3190 NEXT LYNE
3195 RETURN
3200 REM
3205 REM
3210 REM		TIME ACCESS PROGRAM
3215 REM
3220 PRINT CHR$(27);">"
3225 SEC$ = INKEY$
3230 TSEC$ = INKEY$
3235 MIN$ = INKEY$
3240 TMIN$ = INKEY$
3245 HRS$ = INKEY$
3250 THRS$ = INKEY$
3255 TIME$ = THRS$ + HRS$ + ":" + TMIN$ + MIN$
3260 RETURN
3300 REM
3305 REM
3310 REM		DATE ACCESS PROGRAM
3315 REM
3320 PRINT CHR$(27);":"
3325 WKDAY$ = INKEY$
3330 DAY$ = INKEY$
3335 TDAY$ = INKEY$
3340 MO$ = INKEY$
3345 TMO$ = INKEY$
3350 YR$ = INKEY$
3355 TYR$ = INKEY$
3360 DATE$ = TMO$ + MO$ + "/" + TDAY$ + DAY$ + "/" + TYR$ + YR$
3365 IF WKDAY$ = "1" THEN DAYNAME$ = "Sunday"
3370 IF WKDAY$ = "2" THEN DAYNAME$ = "Monday"
3375 IF WKDAY$ = "3" THEN DAYNAME$ = "Tuesday"
3380 IF WKDAY$ = "4" THEN DAYNAME$ = "Wednesday"
3385 IF WKDAY$ = "5" THEN DAYNAME$ = "Thursday"
3390 IF WKDAY$ = "6" THEN DAYNAME$ = "Friday"
3395 IF WKDAY$ = "7" THEN DAYNAME$ = "Saturday"
3400 RETURN
10000 REM
10010 REM
10020 REM	SCREEN PRINT SUBROUTINES
10030 REM
11000 REM
11010 REM
11020 REM	SCREEN - 1
11030 REM
11040 REM GRAPHIC OF OTRONA NAME
11045 GRAPH
11055 REM DRAW "O"
11060 FOR OFFSET = 0 TO 1
11070 P$ = "0"
11080 X = 25 + OFFSET : Y = 220 + OFFSET : GOSUB 2800
11090 P$ = "1"
11100 X = 50 + OFFSET : GOSUB 2800
11110 Y = 200 + OFFSET : GOSUB 2800
11120 X = 25 + OFFSET : GOSUB 2800
11130 Y = 220 + OFFSET : GOSUB 2800
11135 NEXT
11140 REM "O" COMPLETED
11200 REM "T"
11210 FOR OFFSET = 0 TO 1
11220 P$ = "0"
11230 X = 75 + OFFSET : Y = 220 + OFFSET : GOSUB 2800
11240 P$ = "1"
11250 X = 95 + OFFSET : GOSUB 2800
11260 X = 85 + OFFSET : GOSUB 2800
11270 Y = 200 + OFFSET : GOSUB 2800
11280 NEXT
11290 REM "T" COMPLETED
11300 REM "R"
11305 FOR OFFSET = 0 TO 1
11310 P$ = "0"
11315 X = 120 + OFFSET : Y = 200 + OFFSET : GOSUB 2800
11320 P$ = "1"
11322 Y = 220 + OFFSET : GOSUB 2800
11325 X = 140 + OFFSET : GOSUB 2800
11330 Y = 210 + OFFSET : GOSUB 2800
11335 X = 120 + OFFSET : GOSUB 2800
11340 P$ = "0"
11350 X = 135 + OFFSET : Y = 210 + OFFSET : GOSUB 2800
11355 P$ = "1"
11360 X = 145 + OFFSET : Y = 200 + OFFSET : GOSUB 2800
11365 NEXT
11370 REM "R" COMPLETED
11400 REM "O"
11410 FOR OFFSET = 0 TO 1
11420 P$ = "0"
11430 X = 170 + OFFSET : Y = 220 + OFFSET : GOSUB 2800
11440 P$ = "1"
11450 X = 195 + OFFSET : GOSUB 2800
11460 Y = 200 + OFFSET : GOSUB 2800
11470 X = 170 + OFFSET : GOSUB 2800
11480 Y = 220 + OFFSET : GOSUB 2800
11490 NEXT
11495 REM "O" COMPLETED
11500 REM "N"
11510 FOR OFFSET = 0 TO 1
11520 P$ = "0"
11530 X = 220 + OFFSET : Y = 200 + OFFSET : GOSUB 2800
11540 P$ = "1"
11550 Y = 220 + OFFSET : GOSUB 2800
11560 X = 245 + OFFSET : Y = 200 + OFFSET : GOSUB 2800
11570 Y = 220 + OFFSET : GOSUB 2800
11580 NEXT
11590 REM "N" COMPLETED
11600 REM "A"
11605 FOR OFFSET = 0 TO 1
11610 P$ = "0"
11615 X = 270 + OFFSET : Y = 200 + OFFSET : GOSUB 2800
11620 P$ = "1"
11625 Y = 220 + OFFSET : GOSUB 2800
11630 X = 295 + OFFSET : GOSUB 2800
11631 Y = 200 + OFFSET : GOSUB 2800
11635 P$ = "0"
11640 X = 270 + OFFSET : Y = 210 + OFFSET : GOSUB 2800
11645 P$ = "1"
11650 X = 295 + OFFSET : GOSUB 2800
11655 NEXT
11660 REM "A" COMPLETED
11910 RETURN
12000 REM
12010 REM
12020 REM	SCREEN - 2
12030 REM                 
12040 GOSUB 3100 : REM STD TEXT
12045 L = 23: C = 0: GOSUB 2900
12050 RETURN
13000 REM
13010 REM
13020 REM	SCREEN - 3
13030 REM
13100 REM **** ATTACHE DISPLAY CAPABILITIES ****
13105 REM
13110 GRAPH
13115 L = 0: C = 0: GOSUB 2900
13120 PRINT CHR$(27);"S1";CHR$(27);"U(""ATTACHE DISPLAY CAPABILITIES";CHR$(27);"U "
13125 PRINT
13130 FOR J=0 TO 3
13135 PRINT CHR$(27);"T";CHR$(J);
13140 PRINT CHR$(64);"ABCDEFGHIJKLMNOPQRSTUVWXYZ[/]^";CHR$(95)
13145 PRINT "`abcdefghijklmnopqrstuvwxyz{|}~";CHR$(127)
13150 NEXT J
13155 WIDTH 100
13160 PRINT CHR$(27);"T0";CHR$(27);"S0";
13165 PRINT:PRINT CHR$(64);"ABCDEFGHIJKLMNOPQRSTUVWXYZ[/]^";CHR$(95);
13170 PRINT "`abcdefghijklmnopqrstuvwxyz{|}~";CHR$(127)
13175 PRINT CHR$(27);"U! REVERSE ";:GOSUB 13505:PRINT " ";CHR$(27);"U";CHR$(34);" HIGHLIGHT ";
13180 GOSUB 13505
13185 PRINT CHR$(27);"U$ BOLDFACE ";:GOSUB 13505:PRINT CHR$(27);"U SUPER";CHR$(27);"U0SCRIPT ";
13190 GOSUB 13505
13195 PRINT CHR$(27);"U SUB";CHR$(27);"U@SCRIPT "
13200 PRINT CHR$(27);"U(UNDERLINE";:GOSUB 13505:PRINT CHR$(27);"UPSTRIKETHROUGH";
13205 PRINT CHR$(27);"U ";CHR$(27);"S1 DOUBLE SIZE ";
13210 PRINT CHR$(27);"S0STANDARD SIZE"
13215 PRINT CHR$(27);"T1";
13220 REM     FORMS DRAWING
13225 PRINT
13230 PRINT "Q";
13235 FOR I=1 TO 20:PRINT CHR$(64);:NEXT I
13240 PRINT "W";
13245 FOR I=1 TO 6:PRINT CHR$(64);:NEXT I
13250 PRINT"E":PRINT "\                    \      \"
13255 PRINT "A";:FOR I=1 TO 4:PRINT CHR$(64);:NEXT I
13260 PRINT "W";:FOR I=1 TO 15:PRINT CHR$(64);:NEXT I
13265 PRINT "S";:FOR I=1 TO 6:PRINT CHR$(64);:NEXT I:PRINT "D"
13270 FOR J=1 TO 3
13275 PRINT "U";:FOR I=1 TO 4:PRINT CHR$(95);:NEXT I
13280 PRINT"[";:FOR I=1 TO 15:PRINT CHR$(95);:NEXT I
13285 PRINT "[";:FOR I=1 TO 6:PRINT CHR$(95);:NEXT I
13290 PRINT "P":NEXT J
13295 PRINT "Z";:FOR I=1 TO 4:PRINT CHR$(64);:NEXT I
13300 PRINT "X";:FOR I=1 TO 15:PRINT CHR$(64);:NEXT I
13305 PRINT "X";:FOR I=1 TO 6:PRINT CHR$(64);:NEXT I
13310 PRINT "C";
13315 PRINT CHR$(27);"T0"
13320 L=16:C=6:GOSUB 2900:PRINT CHR$(27);"S1FORMS";CHR$(27);"S0"
13325 L=0:C=64:GOSUB 2900:PRINT CHR$(27);"S1GRAPHICS";CHR$(27);"S0"
13330 L=16:C=42:GOSUB 2900:PRINT CHR$(27);"S1FORMULA";CHR$(27);"S0"
13335 L=18:C=49:GOSUB 2900:PRINT CHR$(27);"T3W";CHR$(27);"T0f";
13340 PRINT CHR$(27)"U0(n+1)";CHR$(27);"U ";"(";CHR$(27);"T2x";
13345 PRINT CHR$(27);"T0";")";CHR$(27);"T3E";CHR$(27);"T0";
13350 L=19:C=35:GOSUB 2900:PRINT "f(x)-p(x)=";CHR$(27);"T2C";
13355 PRINT CHR$(27);"T0(x)";CHR$(27);"T3Z";CHR$(27);"T1";
13360 FOR I=1 TO 9:PRINT CHR$(95);:NEXT I
13365 PRINT CHR$(27);"T3Z"
13370 L=20:C=49:GOSUB 2900:PRINT "S";CHR$(27);"T0  (n+1)  ";
13375 PRINT CHR$(27);"T3D"
13380 PRINT CHR$(27);"T0";CHR$(27);"U "
13390 PRINT CHR$(27);"7";
13395 FOR Q=10 TO 160 STEP 50
13400 P$="0":X=273:Y=Q:GOSUB 2800
13405 P$="1":X=302:GOSUB 2800:Y=Q+29:GOSUB 2800
13410 X=273:GOSUB 2800:Y=Q:GOSUB 2800:X=302:GOSUB 2800
13415 X=318:Y=Q+16:GOSUB 2800:Y=Q+45:GOSUB 2800
13420 X=289:GOSUB 2800:X=273:Y=Q+29:GOSUB 2800:X=302:GOSUB 2800
13425 X=318:Y=Q+45:GOSUB 2800
13430 NEXT Q
13435 L=23:C=0:GOSUB 2900
13440 RETURN: REM RETURN TO MAINLINE *****
13505 REM SUBR TO INSERT BLANK SPACE
13510 PRINT CHR$(27);"U    ";
13515 RETURN
14000 REM
14010 REM
14020 REM	SCREEN - 4 - MAP DEMO
14030 REM
14100 REM **** PLOT A FIGURE FROM THE DATA TABLE ****
14105 REM
14110 REM 500=POINT PLOT
14115 REM 501=VECTOR PLOT
14120 REM 503=END OF LIST
14125 REM ANY OTHER NUMBERS ARE TREATED AS X,Y PAIRS
14130 REM
14135 GOSUB 14270: REM INITIALIZE
14140 GRAPH
14142 PRINT CHR$(ESC);"7": REM GRAPHICS ON
14145 FOR I = 1 TO 85
14150 X = PTS%(I)
14155 IF X = 500 THEN P$ = "0": GOTO 14180
14160 IF X = 501 THEN P$ = "1": GOTO 14180
14165 IF X = 503 THEN GOTO 14190
14170 Y = PTS%(I+1): I = I + 1
14175 GOSUB 2800
14180 NEXT
14185 REM PRINT TITLES
14190 L=13:C=12:GOSUB 2900:PRINT "CALIFORNIA"
14195 L=9:C=22:GOSUB 2900:PRINT "NEVADA"
14200 L=10:C=37:GOSUB 2900:PRINT "UTAH"
14205 L=4:C=48:GOSUB 2900:PRINT "WYOMING"
14210 L=10:C=51:GOSUB 2900:PRINT "COLORADO"
14215 L=17:C=35:GOSUB 2900:PRINT "ARIZONA"
14220 L=16:C=52:GOSUB 2900:PRINT "NEW"
14225 L=17:C=51:GOSUB 2900:PRINT "MEXICO"
14230 L=1:C=2:GOSUB 2900:PRINT CHR$(27);"S1SOUTHWESTERN SALES"
14235 PRINT"         REGION";CHR$(27);"S0"
14240 L=23:C=0:GOSUB 2900
14245 RETURN: REM RETURN TO MAINLINE *****
14270 REM 
14275 REM
14280 REM	INITIALIZE
14285 REM
14290 IF MAPSET THEN RETURN
14295 DIM PTS%(85)
14300 PTS%(1) = 500: PTS%(2) = 166: PTS%(3) = 178
14305 PTS%(4) = 501: PTS%(5) = 29: PTS%(6) = 200
14310 PTS%(7) = 24: PTS%(8) = 180: PTS%(9) = 28
14315 PTS%(10) = 145: PTS%(11) = 35: PTS%(12) =136
14320 PTS%(13) = 34: PTS%(14) = 131: PTS%(15) = 48
14325 PTS%(16) = 86: PTS%(17) = 73: PTS%(18) = 70
14330 PTS%(19) = 84: PTS%(20) = 48: PTS%(21) = 110
14335 PTS%(22) = 48: PTS%(23) = 153: PTS%(24) = 24
14340 PTS%(25) = 190: PTS%(26) = 23: PTS%(27) = 190
14345 PTS%(28) = 28: PTS%(29) = 207: PTS%(30) = 28
14350 PTS%(31) = 207: PTS%(32) = 32: PTS%(33) = 251
14355 PTS%(34) = 32: PTS%(35) = 251: PTS%(36) = 102
14360 PTS%(37) = 500: PTS%(38) = 260: PTS%(39) = 102
14365 PTS%(40) = 501: PTS%(41) = 260: PTS%(42) = 160
14370 PTS%(43) = 164: PTS%(44) = 164: PTS%(45) = 170
14375 PTS%(46) = 223: PTS%(47) = 240: PTS%(48) = 220
14380 PTS%(49) = 240: PTS%(50) = 160: PTS%(51) = 500
14385 PTS%(52) = 186: PTS%(53) = 163: PTS%(54) = 501
14390 PTS%(55) = 179: PTS%(56) = 22: PTS%(57) = 500
14395 PTS%(58) = 74: PTS%(59) = 193: PTS%(60) = 501
14400 PTS%(61) = 65: PTS%(62) = 148: PTS%(63) = 125
14405 PTS%(64) = 70: PTS%(65) = 110: PTS%(66) = 48
14410 PTS%(67) = 500: PTS%(68) = 116: PTS%(69) = 82
14415 PTS%(70) = 501: PTS%(71) = 117: PTS%(72) = 97
14420 PTS%(73) = 127: PTS%(74) = 94: PTS%(75) = 136
14425 PTS%(76) = 182: PTS%(77) = 500: PTS%(78) = 129
14430 PTS%(79) = 108: PTS%(80) = 501: PTS%(81) = 182
14435 PTS%(82) = 103: PTS%(83) = 260: PTS%(84) = 102
14440 PTS%(85) = 503
14445 MAPSET = 1
14450 RETURN
15000 REM
15010 REM
15020 REM	SCREEN - 4
15030 REM
15100 REM ***** GENERAL GRAPH PLOTTING PACKAGE *****
15105 REM
15110 REM * GET DATA *
15115 GOSUB 15455
15120 REM * PLOT FRAMEWORK *
15125 GRAPH 
15135 PLOT B(88,205) (288,55)
15150 FOR I=24 TO 64 STEP 8
15155 L = 20: C = I: GRAPH L(L,C): PRINT D
15160 D=D+E:NEXT I
15165 FOR I=0 TO 5
15170 L=19-I*3:C=23:GRAPH L(L,C):PRINT "-"
15172 L=19-I*3:C=19:GRAPH L(L,C):PRINT I*G+F
15175 NEXT
15180 L=1:C=39:GRAPH L(L,C):PRINT A$;
15185 L=2:GRAPH L(L,C):PRINT B$;
15190 L=22:GRAPH L(L,C):PRINT C$;
15195 L=23:GRAPH L(L,C):PRINT D$;
15200 L=11:C=1:GRAPH L(L,C):PRINT E$;
15205 L=12:GRAPH L(L,C):PRINT F$;
15210 L=18:C=4:GRAPH L(L,C):PRINT G$;
15215 L=20:GRAPH L(L,C):PRINT H$;
15217 GRAPH L(24,1)
15218 IF GRAFTYPE = 0 THEN GRAPH N(7)
15219 IF GRAFTYPE = 1 THEN GRAPH N(19)
15220 PLOT B(1,70) (8,60)
15225 PLOT B(1,50) (8,40)
15230 PLOT F(1,50) (8,40)
15255 K=150/(5*G)
15260 IF GRAFTYPE=1 THEN 15360
15265 REM *** PLOT BAR GRAPH ***
15270 FOR I=1 TO 6
15275 Q=(A(I)-F)*K+55
15280 IF Q>205 THEN Q=205
15285 IF Q<56 THEN Q=56
15290 Y=55:X=96+32*(I-1)
15295 PLOT B(X,Q) (X+12,55)
15305 NEXT I
15310 FOR I=1 TO 6
15315 Q=(B(I)-F)*K+55
15320 IF Q>205 THEN Q=205
15325 IF Q<56 THEN Q=56
15330 Y=55:X=108+32*(I-1)
15335 PLOT B(X,Q) (X+12,55)
15340 PLOT F(X,Q) (X+12,55)
15342 Y = 55: PLOT TO (X,Y): X = X + 1: PLOT TO (X,Y)
15345 NEXT I
15350 GOTO 15445
15355 REM *** PLOT LINE GRAPH ***
15360 FOR I=1 TO 6
15365 Q=(A(I)-F)*K+55
15370 IF Q>205 THEN Q=205
15375 IF Q<56 THEN Q=56
15385 X=108+32*(I-1):Y=Q
15386 IF I = 1 THEN PLOT  (X,Y)
15387 IF I > 1 THEN PLOT TO (X,Y)
15390 NEXT I
15395 FOR I=1 TO 5
15400 Q=(B(I)-F)*K+55
15405 Q2=(B(I+1)-F)*K+55
15410 IF Q>205 THEN Q=205
15415 IF Q<57 THEN Q=57
15417 IF Q2 > 205 THEN Q2 = 205
15418 IF Q2 < 57  THEN Q2 = 57
15420 X=108+32*(I-1):Y=Q:PLOT (X,Y)
15425 X=108+32*I:Y=Q2:PLOT TO (X,Y)
15430 Y=Y-1:PLOT TO (X,Y):X=X-32:Y=Q-1:PLOT TO (X,Y)
15435 Y=Y-1:PLOT TO (X,Y):X=X+32:Y=Q2-1:PLOT TO (X,Y)
15440 NEXT I
15445 RETURN: REM RETURN TO MAINLINE *****
15455 REM PLUG IN VALUES FOR DEMO
15460 A$="   S H I P P I N G    "
15465 B$="P E R F O R M A N C E  "
15470 C$="    Y E A R     "
15475 D$=""
15480 E$=" MILLIONS  "
15485 F$="OF DOLLARS "
15490 G$="TARGET"
15495 H$="ACTUAL"
15500 D=1975
15505 E=1
15510 F=0
15515 G=1
15520 A(1) = 1!: A(2) = 1.5: A(3) = 2.1
15525 A(4) = 3!: A(5) = 4!: A(6) = 4.2
15530 B(1) = .8: B(2) = 1.9: B(3) = 2.4
15535 B(4) = 2.7: B(5) = 3!: B(6) = 4.6
15540 REM FIRST PASS GRAFTYPE = 0  BAR GRAPH
15545 RETURN
16000 REM
16010 REM
16020 REM	SCREEN - 6 - LINE GRAPH DEMO
16030 REM
16105 REM
16110 GRAFTYPE = 1
16115 GOSUB 15000
16120 GRAFTYPE = 0
16125 RETURN: REM RETURN TO MAINLINE *****
17000 REM
17010 REM
17020 REM	SCREEN - 7 - TWIL DEMO
17030 REM
17100 REM **** SQUARE TUNNEL PLOT ****
17105 REM
17110 GRAPH
17120 B=100
17125 FOR A=100 TO -119 STEP -3
17130 X = 160 - B: Y = 120 + A: PLOT (X,Y)
17135 X=160+A:Y=120+B:PLOT TO (X,Y):X=160+B:Y=120-A:PLOT TO (X,Y)
17140 X=160-A:Y=120-B:PLOT TO (X,Y):X=160-B:Y=120+A:PLOT TO (X,Y)
17145 B=B-2:NEXT 
17150 GOSUB 1000: REM PAUSE
17155 X = 160
17165 Y = 125
17175 ANGLE = 360
17185 GRAPH
17205 FOR J = 1 TO 2
17215 IF J = 2 THEN GRAPH C
17225 FOR I = 10 TO 100 STEP 10
17235 PLOT (X,Y)
17245 PLOT C(X + I,Y), ANGLE
17255 ANGLE = - ANGLE
17265 NEXT I
17275 NEXT J
17285 GRAPH B
17290 RETURN
18000 REM
18010 REM
18020 REM	SCREEN - 8 - WP DEMO
18030 REM
18040 GOSUB 3100: REM STANDARD TEXT
18050 RETURN: REM RETURN TO MAINLINE *****
19000 REM
19010 REM
19020 REM	SCREEN - 9 - SPREAD SHEET
19030 REM
19040 GOSUB 3100: REM STANDARD TEXT
19050 RETURN
20000 REM
20010 REM
20020 REM	SCREEN - 10 - CLOSING MESSAGE
20030 REM
20040 GOSUB 11000: REM GRAPH OF 'OTRONA'
20045 GOSUB 3100: REM STANDARD TEXT
20050 GOSUB 3300: REM DATE
20055 L = 18: C = 36: GOSUB 2900
20060 PRINT CHR$(ESC);"S1On ";DAYNAME$;", ";DATE$
20065 FOR PAUSE = 1 TO 1000: NEXT
20070 GOSUB 3200: REM TIME
20075 L = 21: C = 44: GOSUB 2900
20080 PRINT "Current Time ";CHR$(ESC);"U!";TIME$
20085 RETURN: REM RETURN TO MAINLINE *****
60000 REM
60010 REM
60020 REM	INITIALIZE VARIABLES, FLAGS, ARRAYS, DATA
60030 REM
60050 DEFINT X-Y,C,L
60100 REM
60110 REM
60120 REM	FLAGS
60130 REM
60140 DEMO = 1
60190 REM
60200 REM
60210 REM
60220 REM	VARIABLES
60230 REM
60240 NMSCRN = 10
60250 ESC = 27
60280 REM	NMSCRN 		NUMBER OF SCREENS
60281 REM	SCREEN		INDEX FOR SCREEN IN USE
60282 REM	LYNE		'DATA' LINE FOR SCREEN
60283 REM	CHAR		CHARACTERISTIC (X,Y,ATTRIB,ETC)
60284 REM	PAUSE		COUNT FOR PAUSE
60285 REM	NUMLYNE		NUMBER OF LINES FOR A SCREEN
60286 REM	ESC		ESCAPE IS CHAR 27
60290 REM
60295 GOSUB 2500: GOSUB 2700: REM CLEAR GRAPHICS & TEXT
60300 REM
60310 REM
60320 REM	ARRAYS
60330 REM
60340 DIM SCREEN$(10,21),SCRN%(10,21,8)
60380 REM	SCREEN$		TEXT FOR SCREEN (1 TO 20 LINES)
60381 REM	SCRN%		SCREEN CHARACTERISTICS
60382 REM			SCRN%(SCREEN,LINE,CHAR)
60383 REM			CHAR = 0  LINE 1 - NUM OF LINES
60384 REM			1 = CPOS  2 = LINE 3 = COL
60385 REM			4 = CSET  5 = SIZE 6 = ATTR
60386 REM                       7 = CLR SCRN       8 = CLR GRPH
60400 REM
60405 REM PAUSE FOR SCREENS - DELAY ARRAY
60410 DIM DELAY(12)
60415 DELAY(1) = 0:REM SCREEN 1
60420 DELAY(2) = 1400:REM SCREEN 2
60425 DELAY(3) = 8000:REM SCREEN 3 DISPLAY DEMO
60430 DELAY(4) = 1600:REM SCREEN 4 MAP DEMO 
60435 DELAY(5) = 4000:REM SCREEN 5 BAR CHART
60440 DELAY(6) = 3400: REM SCREEN 6 LINE CHART
60445 DELAY(7) = 1100:REM SCREEN 7 TWIL GRAPHICS
60450 DELAY(8) = 6000:REM SCREEN 8 WP DEMO
60455 DELAY(9) = 4000:REM SCREEN 9 SPREAD SHEET
60460 DELAY(10)= 1600:REM SCREEN 10 EXIT MESSAGE
61000 REM
61005 REM
61010 REM	SCREEN DATA READ ROUTINE
61015 REM
61020 FOR SCREEN = 1 TO NMSCRN
61025	READ NUMLYNE
61026	SCRN%(SCREEN,0,0) = NUMLYNE
61029   IF NUMLYNE = 0 THEN 61060
61030	FOR LYNE = 1 TO NUMLYNE
61035		FOR CHAR = 1 TO 8
61040			READ SCRN%(SCREEN,LYNE,CHAR)
61045		NEXT CHAR
61050		READ SCREEN$(SCREEN,LYNE)
61055	NEXT LYNE
61060 NEXT SCREEN
61065 RETURN
61100 REM
61110 REM
61120 REM	SCREEN - 1 - GRAPHICS "OTRONA" TITLE SCREEN
61130 REM
61140 DATA 0 : REM 0 LINES
61200 REM
61210 REM
61220 REM	SCREEN - 2 - REST OF TITLE SCREEN
61230 REM
61240 DATA 5 : REM 5 LINES
61250 REM LINE 1
61260 DATA 1,9,35,0,0,32,0,0
61262 DATA "PRESENTS"
61265 REM LINE 2
61267 DATA 1,14,26,0,1,36,0,0
61269 DATA "A T T A C H E"
61270 REM LINE 3
61272 DATA 1,13,52,0,0,64,0,0
61274 DATA "tm"
61275 REM LINE 4
61277 DATA 1,19,18,0,1,33,0,0
61279 DATA "THE EXECUTIVE COMPUTER"
61280 REM LINE 5
61282 DATA 1,18,62,0,0,64,0,0
61284 DATA "tm"
61300 REM
61310 REM
61320 REM	SCREEN - 3 - DISPLAY DEMO
61330 REM
61340 DATA 0 : REM 0 LINES
61350 REM LINE 1
61400 REM
61410 REM
61420 REM	SCREEN - 4 - MAP DEMO
61430 REM
61440 DATA 0 : REM 0 LINES
61450 REM LINE 1
61500 REM
61510 REM
61520 REM	SCREEN - 5 - BAR GRAPH DEMO
61530 REM
61540 DATA 0 : REM 0 LINES
61550 REM LINE 1
61600 REM
61610 REM
61620 REM	SCREEN - 6 - LINE GRAPH DEMO
61630 REM
61640 DATA 0 : REM 0 LINES
61650 REM LINE 1
61700 REM
61710 REM
61720 REM	SCREEN - 7 - TWIL DEMO
61730 REM
61740 DATA 0 : REM 0 LINES
61750 REM LINE 1
61800 REM
61810 REM
61820 REM	SCREEN - 8 - WP DEMO
61830 REM
61840 DATA 13 : REM 13 LINES
61850 DATA 1,2,7,0,1,36,1,1
61851 DATA "A T T A C H E  with WORDSTAR-PLUS"
61852 DATA 1,1,33,0,0,64,0,0
61853 DATA "tm"
61854 DATA 1,1,73,0,0,64,0,0
61855 DATA "tm"
61856 DATA 1,6,21,0,0,32,0,0
61857 DATA "WORDSTAR-PLUS - EASY TO LEARN AND PERFORMS"
61858 DATA 1,8,21,0,0,32,0,0
61859 DATA "ALL OF YOUR  'WORD PROCESSINGS'  FUNCTIONS"
61860 DATA 1,12,15,0,0,34,0,0
61861 DATA           "A:ATTACHE  PAGE  5 LINE 22 COL 45"
61862 DATA 1,13,10,0,0,34,0,0
61863 DATA "L----!----!----!----!----!----!----!----!----!----!----!----!---R"
61866 DATA 1,14,10,0,0,32,0,0
61867 DATA "ATTACHE features  'WordStar-Plus'  word processing.  Our keyboard"
61868 DATA 1,15,10,0,0,32,0,0
61869 DATA "reference template makes it easier for you to learn and use Word-"
61870 DATA 1,16,10,0,0,32,0,0
61871 DATA "Star-Plus.   Formulating and arranging your ideas directly on the"
61872 DATA 1,17,10,0,0,32,0,0
61873 DATA "screen offers you the maximum in freedom and flexibility.   Enter"
61874 DATA 1,18,10,0,0,32,0,0
61875 DATA "your thoughts as they come to you; from the beginning, middle, or"
61876 DATA 1,19,10,0,0,32,0,0
61877 DATA "end.  Changes, additions, or deletions are easy with Attache.    <"
61900 REM
61910 REM
61920 REM	SCREEN - 9 - SPREADSHEET DEMO
61930 REM
61940 DATA 21 : REM 21 LINES
61950 REM LINE 1
61951 DATA 1,2,26,0,1,36,1,1
61952 DATA "A T T A C H E"
61953 DATA 1,1,52,0,0,64,0,0
61954 DATA "tm"
61955 DATA 1,5,16,0,0,32,0,0
61956 DATA "SUPPORTS CP/M BASED 'SPREADSHEET CALCULATORS' FOR"
61957 DATA 1,7,16,0,0,32,0,0
61958 DATA "YOUR BUSINESS AND FINANCIAL PLANNING REQUIREMENTS"
61959 REM
61960 DATA 1,10,10,0,0,32,0,0
61961 DATA  "   |         A        ||   B   ||   C   ||   D   ||   E   |"
61962 DATA 1,11,10,0,0,32,0,0
61963 DATA  " 1|"
61964 DATA 1,12,10,0,0,32,0,0
61965 DATA  " 2|"
61966 DATA 1,12,34,0,0,36,0,0
61967 DATA     "BALANCE  SHEET"
61968 DATA 1,13,10,0,0,32,0,0
61969 DATA  " 3|"
61970 DATA 1,14,10,0,0,32,0,0
61971 DATA  " 4|"
61972 DATA 1,14,13,0,0,36,0,0
61973 DATA      "                         Jan      Feb      Mar      Apr"
61974 DATA 1,15,10,0,0,32,0,0
61976 DATA  " 5|"
61977 DATA 1,15,13,0,0,36,0,0
61978 DATA     "ASSETS"
61979 DATA 1,16,10,0,0,32,0,0
61980 DATA  " 6|Receivables           1000.00  1200.00  1150.75  1475.25"
61981 DATA 1,17,10,0,0,32,0,0
61982 DATA  " 7|Inventory              750.00   875.00   750.55   525.30"
61983 DATA 1,18,10,0,0,32,0,0
61984 DATA  " 8|Cash on Hand           450.35   760.98  6637.48   345.56"
61985 DATA 1,19,10,0,0,32,0,0
61986 DATA  " 9|"
61987 DATA 1,19,13,0,0,36,0,0
61988 DATA     "--------------------------------------------------------"
61989 DATA 1,20,10,0,0,32,0,0
61990 DATA  "10|"
61991 DATA 1,20,13,0,0,36,0,0
61992 DATA     "Total Assets"
61993 DATA 1,20,35,0,0,32,0,0
61994 DATA                           "2200.35  2835.98  8538.78  2346.11"
62000 REM
62010 REM
62020 REM	SCREEN - 10 - CLOSING MESSAGE
62030 REM
62040 DATA 6 : REM 6 LINES
62050 REM LINE 1
62061 DATA 1,6,6,0,1,32,0,0
62062 DATA "THANKS YOU"
62063 DATA 1,9,14,0,1,32,0,0
62064 DATA "FOR LOOKING AT"
62065 DATA 1,12,22,0,1,32,0,0
62066 DATA "A T T A C H E"
62067 DATA 1,11,48,0,0,64,0,0
62068 DATA "tm"
62069 DATA 1,15,30,0,1,33,0,0
62070 DATA "THE EXECUTIVE COMPUTER"
62071 DATA 1,14,74,0,0,64,0,0
62072 DATA "tm"
65000 RETURN
69 DATA 1,15,30,0,1,33,0,0
620